#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorDrawCFG.h"
std::auto_ptr<Fish_SeniorDrawCFG> Fish_SeniorDrawCFG::msSingleton(nullptr);

int Fish_SeniorDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorDrawCFGData* Fish_SeniorDrawCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorDrawCFGData>& Fish_SeniorDrawCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorDrawCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorDrawCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorDrawCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishId = element->IntAttribute("FishId");
		{
			const char* GraphicalId = element->Attribute("GraphicalId");
			std::vector<std::string> vecGraphicalId;
			boost::split(vecGraphicalId, GraphicalId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGraphicalId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGraphicalId[i].c_str(), &temp))
				{
					data.mGraphicalId.push_back(temp);
				}
			}
		}
		data.mmult = element->IntAttribute("mult");
		data.mLotteryProbability = element->IntAttribute("LotteryProbability");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorDrawCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorDrawCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorDrawCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorDrawCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "FishId", data.mFishId);
		LuaCfgHelper::readVectorInt(L, "GraphicalId", data.mGraphicalId);
		LuaCfgHelper::readInt(L, "mult", data.mmult);
		LuaCfgHelper::readInt(L, "LotteryProbability", data.mLotteryProbability);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorDrawCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorDrawCFG* Fish_SeniorDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorDrawCFG());
	}
	return msSingleton.get();
}

void Fish_SeniorDrawCFG::Release()
{
	msSingleton.reset(nullptr);
}
